<%@ WebService Language="C#" Class="Jeffz.AutoCompleteDemo.EmailSuggestService" %>

using System;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.Collections.Generic;
using System.IO;


namespace Jeffz.AutoCompleteDemo
{
	[WebService(Namespace = "http://tempuri.org/")]
	[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
	public class EmailSuggestService : System.Web.Services.WebService
	{
		private static string[] EmailList = null;
		
		[WebMethod]
		public List<EmailSuggest> GetEmailSuggest(string prefixText, int count)
		{
			if (EmailList == null)
			{
				EmailList = File.ReadAllLines(Server.MapPath("~/App_Data/EmailSuggest.txt"));
			}

			List<EmailSuggest> result = new List<EmailSuggest>(count);
			for (int i = 0; i < EmailList.Length && result.Count < count; i++)
			{
				if (EmailList[i].IndexOf(prefixText) >= 0)
				{
					EmailSuggest suggest = new EmailSuggest();
					suggest.Email = EmailList[i];
					suggest.EncodedEmailSuggest = this.Server.HtmlEncode(EmailList[i]).Replace(
						prefixText, "<b>" + prefixText + "</b>");

					result.Add(suggest);
				}
			}

			return result;
		}
	}
	
	public class EmailSuggest
	{
		public string Email;

		public string EncodedEmailSuggest;
	}

}