<%@ WebService Language="C#" Class="Jeffz.AutoCompleteDemo.SearchSuggestService" %>
 
using System;
using System.IO;
using System.Web;
using System.Collections;
using System.Collections.Generic;
using System.Threading;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.Xml.Serialization;
 
namespace Jeffz.AutoCompleteDemo
{
	[WebService(Namespace =  "http://tempuri.org/")]
	[WebServiceBinding(ConformsTo =  WsiProfiles.BasicProfile1_1)]
	public class SearchSuggestService : System.Web.Services.WebService
	{
		private static SearchResult[] searchWordsList = null;

		[WebMethod]
		public List<SearchResult> GetSearchWords(string prefixText, int count)
		{
			if (searchWordsList == null)
			{
				string[] temp = File.ReadAllLines(Server.MapPath("~/App_Data/SearchSuggest.txt"));
				searchWordsList = new SearchResult[temp.Length];

				Random random = new Random(DateTime.Now.Millisecond);
				for (int i = 0; i < temp.Length; i++)
				{
					searchWordsList[i] = new SearchResult(temp[i], random.Next(10000));
				}
			}

			List<SearchResult> result = new List<SearchResult>(count);
			for (int j = 0; j < searchWordsList.Length && result.Count < count; j++)
			{
				if (searchWordsList[j].Keyword.StartsWith(prefixText, StringComparison.InvariantCultureIgnoreCase))
				{
					result.Add(searchWordsList[j]);
				}
			}

			result.Sort();
			return result;
		}
	}

	public class SearchResult : IComparable<SearchResult>
	{
		public string Keyword;

		public int Result;
		
		public SearchResult() { }

		public SearchResult(string keyword, int result)
		{
			this.Keyword = keyword;
			this.Result = result;
		}

		public int CompareTo(SearchResult other)
		{
			if (this.Result != other.Result)
			{
				return other.Result.CompareTo(this.Result);
			}

			return this.Keyword.CompareTo(other.Keyword);
		}
	}

}
